#include <stdlib.h>
#include <android/bitmap.h>

#include "ComicFinder.hpp"

JNIEXPORT bool JNICALL Java_com_example_comicfinder_MainActivity_processImage
    (JNIEnv *env, jobject me, jbyteArray src, jobject dst, jint width, jint height)
{
    int ret;
    unsigned char *p_dst;
    if ((ret = AndroidBitmap_lockPixels(env, dst, reinterpret_cast<void **>(&p_dst))) < 0) {
        return false;
    }

    unsigned char *p_src = reinterpret_cast<unsigned char *>(env->GetPrimitiveArrayCritical(src, NULL));
    if (NULL == p_src) {
        AndroidBitmap_unlockPixels(env, dst);
        return false;
    }

    for (int k = 0; k < width*height; k++) {
        p_dst[k*4+0] = p_dst[k*4+1] = p_dst[k*4+2] = p_src[k];
        p_dst[k*4+3] = 0xff;
    }

    env->ReleasePrimitiveArrayCritical(src, p_src, 0);
    AndroidBitmap_unlockPixels(env, dst);

    return true;
}
